from .access_layers import SubmodelAccessLayer

def build_context(access_layer: SubmodelAccessLayer):
    type_name = access_layer.get_type()

    context = {
        'Parent': access_layer.get_parent(),
        'Type': type_name,
        'Name': access_layer.get_name(),
        'Anim': access_layer.get_anim(),
        'Diffuse': access_layer.get_diffuse(),
        'SelfIllum': access_layer.get_selfillum(),
        'MaxDistance': access_layer.get_max_distance(),
        'MinDistance': access_layer.get_min_distance(),
        'Transform': access_layer.get_transform(),
        'NumVerts': access_layer.get_num_verts(),
        'vertex_groups': access_layer.get_vertex_groups()
    }

    if type_name == 'Mesh':
        context.update({
            'Ambient': access_layer.get_ambient(),
            'Specular': access_layer.get_specular(),
            'Wire': access_layer.get_wire(),
            'WireSize': access_layer.get_wire_size(),
            'Opacity': access_layer.get_opacity(),
            'Map': access_layer.get_map(),
        })

    elif type_name == 'FreeSpotLight':
        context.update({
            'NearAttenStart': access_layer.get_near_atten_start(),
            'NearAttenEnd': access_layer.get_near_atten_end(),
            'UseNearAtten': access_layer.get_use_near_atten(),
            'FarAttenDecayType': access_layer.get_far_atten_decay_type(),
            'FarDecayRadius': access_layer.get_far_decay_radius(),
            'FalloffAngle': access_layer.get_falloff_angle(),
            'HotspotAngle': access_layer.get_hotspot_angle()
        })

    return context
